static int fr = 10;

String path00 = "Data/00 Base";
String path20 = "Data/20 Base";
String path40 = "Data/40 Base";

ArrayList <PImage> b0;
ArrayList <PImage> b2;
ArrayList <PImage> b4;

PImage drawMe;

boolean faceRight = true;
boolean running = false;
boolean jump = false;
int weightClass = 0;
int frame = 0;
int slide = 0;
int fall = 0;

void setup(){
  b0 = new ArrayList<PImage>();
  b0.add(loadImage(path00 + "/Fall Left 00.png"));    //0
  b0.add(loadImage(path00 + "/Fall Right 00.png"));   //1
  b0.add(loadImage(path00 + "/Idle Left 00.png"));    //2
  b0.add(loadImage(path00 + "/Idle Left 01.png"));    //3
  b0.add(loadImage(path00 + "/Idle Left 02.png"));    //4
  b0.add(loadImage(path00 + "/Idle Left 03.png"));    //5
  b0.add(loadImage(path00 + "/Idle Right 00.png"));   //6
  b0.add(loadImage(path00 + "/Idle Right 01.png"));   //7
  b0.add(loadImage(path00 + "/Idle Right 02.png"));   //8
  b0.add(loadImage(path00 + "/Idle Right 03.png"));   //9
  b0.add(loadImage(path00 + "/Jump Left 00.png"));    //10
  b0.add(loadImage(path00 + "/Jump Right 00.png"));   //11
  b0.add(loadImage(path00 + "/Run Left 00.png"));     //12
  b0.add(loadImage(path00 + "/Run Left 01.png"));    //13
  b0.add(loadImage(path00 + "/Run Left 02.png"));    //14
  b0.add(loadImage(path00 + "/Run Left 03.png"));    //15
  b0.add(loadImage(path00 + "/Run Left 04.png"));    //16
  b0.add(loadImage(path00 + "/Run Left 05.png"));    //17
  b0.add(loadImage(path00 + "/Run Left 06.png"));    //18
  b0.add(loadImage(path00 + "/Run Left 07.png"));    //19
  b0.add(loadImage(path00 + "/Run Right 00.png"));    //20
  b0.add(loadImage(path00 + "/Run Right 01.png"));    //21
  b0.add(loadImage(path00 + "/Run Right 02.png"));    //22
  b0.add(loadImage(path00 + "/Run Right 03.png"));    //23
  b0.add(loadImage(path00 + "/Run Right 04.png"));    //24
  b0.add(loadImage(path00 + "/Run Right 05.png"));    //25
  b0.add(loadImage(path00 + "/Run Right 06.png"));    //26
  b0.add(loadImage(path00 + "/Run Right 07.png"));    //27
  b0.add(loadImage(path00 + "/Slip Left 00.png"));    //28
  b0.add(loadImage(path00 + "/Slip Left 01.png"));    //29
  b0.add(loadImage(path00 + "/Slip Left 02.png"));    //30
  b0.add(loadImage(path00 + "/Slip Right 00.png"));    //31
  b0.add(loadImage(path00 + "/Slip Right 01.png"));    //32
  b0.add(loadImage(path00 + "/Slip Right 02.png"));    //33

  b2 = new ArrayList<PImage>();
  b2.add(loadImage(path20 + "/Fall Left 00.png"));
  b2.add(loadImage(path20 + "/Fall Right 00.png"));
  b2.add(loadImage(path20 + "/Idle Left 00.png"));
  b2.add(loadImage(path20 + "/Idle Left 01.png"));
  b2.add(loadImage(path20 + "/Idle Left 02.png"));
  b2.add(loadImage(path20 + "/Idle Left 03.png"));
  b2.add(loadImage(path20 + "/Idle Right 00.png"));
  b2.add(loadImage(path20 + "/Idle Right 01.png"));
  b2.add(loadImage(path20 + "/Idle Right 02.png"));
  b2.add(loadImage(path20 + "/Idle Right 03.png"));
  b2.add(loadImage(path20 + "/Jump Left 00.png"));
  b2.add(loadImage(path20 + "/Jump Right 00.png"));
  b2.add(loadImage(path20 + "/Run Left 00.png"));
  b2.add(loadImage(path20 + "/Run Left 01.png"));
  b2.add(loadImage(path20 + "/Run Left 02.png"));
  b2.add(loadImage(path20 + "/Run Left 03.png"));
  b2.add(loadImage(path20 + "/Run Left 04.png"));
  b2.add(loadImage(path20 + "/Run Left 05.png"));
  b2.add(loadImage(path20 + "/Run Left 06.png"));
  b2.add(loadImage(path20 + "/Run Left 07.png"));
  b2.add(loadImage(path20 + "/Run Right 00.png"));
  b2.add(loadImage(path20 + "/Run Right 01.png"));
  b2.add(loadImage(path20 + "/Run Right 02.png"));
  b2.add(loadImage(path20 + "/Run Right 03.png"));
  b2.add(loadImage(path20 + "/Run Right 04.png"));
  b2.add(loadImage(path20 + "/Run Right 05.png"));
  b2.add(loadImage(path20 + "/Run Right 06.png"));
  b2.add(loadImage(path20 + "/Run Right 07.png"));
  b2.add(loadImage(path20 + "/Slip L 00.png"));
  b2.add(loadImage(path20 + "/Slip L 01.png"));
  b2.add(loadImage(path20 + "/Slip L 02.png"));
  b2.add(loadImage(path20 + "/Slip R 00.png"));
  b2.add(loadImage(path20 + "/Slip R 01.png"));
  b2.add(loadImage(path20 + "/Slip R 02.png"));
  
  b4 = new ArrayList<PImage>();
  b4.add(loadImage(path40 + "/Fall Left 00.png"));
  b4.add(loadImage(path40 + "/Fall Right 00.png"));
  b4.add(loadImage(path40 + "/Idle Left 00.png"));
  b4.add(loadImage(path40 + "/Idle Left 01.png"));
  b4.add(loadImage(path40 + "/Idle Left 02.png"));
  b4.add(loadImage(path40 + "/Idle Left 03.png"));
  b4.add(loadImage(path40 + "/Idle Right 00.png"));
  b4.add(loadImage(path40 + "/Idle Right 01.png"));
  b4.add(loadImage(path40 + "/Idle Right 02.png"));
  b4.add(loadImage(path40 + "/Idle Right 03.png"));
  b4.add(loadImage(path40 + "/Jump Left 00.png"));
  b4.add(loadImage(path40 + "/Jump Right 00.png"));
  b4.add(loadImage(path40 + "/Run Left 00.png"));
  b4.add(loadImage(path40 + "/Run Left 01.png"));
  b4.add(loadImage(path40 + "/Run Left 02.png"));
  b4.add(loadImage(path40 + "/Run Left 03.png"));
  b4.add(loadImage(path40 + "/Run Left 04.png"));
  b4.add(loadImage(path40 + "/Run Left 05.png"));
  b4.add(loadImage(path40 + "/Run Left 06.png"));
  b4.add(loadImage(path40 + "/Run Left 07.png"));
  b4.add(loadImage(path40 + "/Run Right 00.png"));
  b4.add(loadImage(path40 + "/Run Right 01.png"));
  b4.add(loadImage(path40 + "/Run Right 02.png"));
  b4.add(loadImage(path40 + "/Run Right 03.png"));
  b4.add(loadImage(path40 + "/Run Right 04.png"));
  b4.add(loadImage(path40 + "/Run Right 05.png"));
  b4.add(loadImage(path40 + "/Run Right 06.png"));
  b4.add(loadImage(path40 + "/Run Right 07.png"));
  b4.add(loadImage(path40 + "/Slip Left 00.png"));
  b4.add(loadImage(path40 + "/Slip Left 01.png"));
  b4.add(loadImage(path40 + "/Slip Left 02.png"));
  b4.add(loadImage(path40 + "/Slip Right 00.png"));
  b4.add(loadImage(path40 + "/Slip Right 01.png"));
  b4.add(loadImage(path40 + "/Slip Right 02.png"));
  
  drawMe = b0.get(6);
  size(150, 150);
  frameRate(fr);
}

void draw(){
  background(10);
  frame = (frame + 1) % 8;
  slide--;
  if (slide < 0) slide = 0;
  fall--;
  if (fall < 0) fall = 0;
  getSprite();
  image(drawMe, (width - drawMe.width)/2, 10);
}

void keyPressed(){
  if (key == CODED) {
    //UP, DOWN, LEFT, RIGHT, ALT, CONTROL, and SHIFT
    if (keyCode == UP) {
      weightClass = (weightClass + 2) % 6;
    }
    else if (keyCode == LEFT){
      faceRight = false;
      running = true;
    }
    else if (keyCode == RIGHT){
      faceRight = true;
      running = true;
    }
  }
  else if (key == ' '){
    jump = true;
  }
}

void keyReleased() {
  if (key == CODED) {
    if (keyCode == RIGHT || keyCode == LEFT){
      running = false;
      slide = 12;
    }
  }
  else if(key == ' '){
    jump = false;
    fall = 12;
  }
}

void getSprite(){
  if (faceRight){
    switch (weightClass){
      case 0:
        if (running){
          drawMe = b0.get(20+frame);
        }
        else if(slide != 0){
          drawMe = b0.get(31+(slide/4));
        }
        else if(jump){
          drawMe = b0.get(11);
        }
        else if(fall != 0){
          drawMe = b0.get(1);
        }
        else {
          drawMe = b0.get(6+frame/2);
        }
      break;
      case 2:
        if (running){
          drawMe = b2.get(20+frame);
        }
        else if(slide != 0){
          drawMe = b2.get(31+(slide/4));
        }
        else if(jump){
          drawMe = b2.get(11);
        }
        else if(fall != 0){
          drawMe = b2.get(1);
        }
        else {
          drawMe = b2.get(6+frame/2);
        }
      break;
      case 4:
        if (running){
          drawMe = b4.get(20+frame);
        }
        else if(slide != 0){
          drawMe = b4.get(31+(slide/4));
        }
        else if(jump){
          drawMe = b4.get(11);
        }
        else if(fall != 0){
          drawMe = b4.get(1);
        }
        else {
          drawMe = b4.get(6+frame/2);
        }
      break;
    }
  }
  else {
    switch (weightClass){
      case 0:
        if (running){
          drawMe = b0.get(12+frame);
        }
        else if(slide != 0){
          drawMe = b0.get(28+(slide/4));
        }
        else if(jump){
          drawMe = b0.get(10);
        }
        else if(fall != 0){
          drawMe = b0.get(0);
        }
        else {
          drawMe = b0.get(2+frame/2);
        }
      break;
      case 2:
        if (running){
          drawMe = b2.get(12+frame);
        }
        else if(slide != 0){
          drawMe = b2.get(28+(slide/4));
        }
        else if(jump){
          drawMe = b2.get(10);
        }
        else if(fall != 0){
          drawMe = b2.get(0);
        }
        else {
          drawMe = b2.get(2+frame/2);
        }
      break;
      case 4:
        if (running){
          drawMe = b4.get(12+frame);
        }
        else if(slide != 0){
          drawMe = b4.get(28+(slide/4));
        }
        else if(jump){
          drawMe = b4.get(10);
        }
        else if(fall != 0){
          drawMe = b4.get(0);
        }
        else {
          drawMe = b4.get(2+frame/2);
        }
      break;
    }
  }
}
